#ifndef __manifold_h__
#define __manifold_h__

/* the size of the window */
#define WIN_SIZE_X 640
#define WIN_SIZE_Y 500

/* set the velosity of the wave */
#define WAVER_VELOSITY 10.0

/* define a waver */
typedef struct waver {
  int x,y;       /* loc of wave         */
  double px,py;  /* the origin point    */
  int v;          /* velosity            */
  int m;          /* mass either 1 or -1 */
} WAVER, *WAVER_PTR;

/* what's in a manifold */
typedef struct manifold {
  double x;
  double y;
} MAN, *MAN_PTR;

/* and export the manifold */
extern MAN man[WIN_SIZE_X][WIN_SIZE_Y];

#ifdef __cplusplus
extern "C" {
#endif

/* zero the manifold */
void zero_manifold ( void );
/* create a new waver */
WAVER_PTR waver_new ( double px, double py, int v, int m );
/* propogate a wave once */
int waver_propogate ( WAVER_PTR w );

#ifdef __cplusplus
};
#endif

#endif /* __manifold_h__ */

